Subject: Re: Should setup suggests to downgrade? [WAS: Lillypond for cygwin]
From: "Cliff Hones" <[email-masked]>
To: "Robert Collins" <[email-masked]>, <[email-masked]>
Date: Sat, 6 Apr 2002 17:09:43 +0100

> From: "Robert Collins" <[email-masked]>
> Sent: Saturday, April 06, 2002 3:10 PM
>
> > From: Cliff Hones [mailto:[email-masked]] 
> > Sent: Sunday, April 07, 2002 12:07 AM
> 
> Thanks for the feedback.. I'll have a look in the logs tomorrow.

Oops - please ignore the last attachment - I mistakenly sent
the wrong log.  Correct one attached this time (had to recreate
the scenario, so it's a solid problem).  

> > [I've already mentioned I'm not happy with the current 
> > download mode - I think it loses a lot of its potential 
> > power, and is also confusing, by being intertwined with the 
> > current install state. 
> 
> And yet, I can see a lot of annoyed folk if setup in download mode tried
> to download *everything* not present by default. It's easy enough to
> tell setup to download everything regardless of local state - click all
> categorie's action symbol to redownload, and you are done. Does that
> address your concern?

No - my main concern is that setup.exe doesn't notice that packages are
already present in the local directory if they're not also installed.
The way I'd like to work is to have a (not necessarily complete)
local directory, and to have a subset of that currently installed.
From time to time, to see what's new, I'd like to run in 'download'
mode, and be shown all the new and updated packages available since
last time.  I'd like to be able to choose which of these to download.
And then I'd like to be able to run in local install mode and be offered
these newly-downloaded packages, so I can again selectively install them.
Currently what I see is that in download mode I'm offered all the
non-installed packages to download, even if they're already in the local
directory, and in install mode I'm offered packages which aren't actually
present locally.  Is this the intention?

> Anyway, I may misunderstand what you meant, so feel free to elaborate or
> patch.

Oh, if only.  I'd love to have the time to patch, but failing that I hope
I can at least make useful comments.
 
> > Indeed, I see little value in 
> > separating the download and install as currently implemented. 
> >  Seeing no comment after my earlier mail, do I assume I'm 
> > either doing something wrong, or nobody else finds 
> > this a problem?]
> 
> Simply use the 'install from internet' mode. It downloads and installs
> in one foul swoop.

Yes - that was really my point.  Given that the 'download' and
'install from local' modes are offered, I'd assume there was some
extra functionality available - but it doesn't seem to quite
hang together when run this way at the moment.

I guess I have a mindset of how I'd been expecting it to work.  Maybe
it would help if I explain this in more detail, rather than just whinge :-).

- In local download mode:
  State stored in local dir includes proxy info and mirror(s) previously used.
  Default view should offer to download any updated versions of all packages
  currently found in the local dir.  Should also add in missing files
  required by dependencies, and all the 'base' packages (in case any
  new ones have been added).  [Old setup used to cope with packages
  in the directory but not in setup.ini.  Should this still be possible?]
  Should be no need to refer to the current installation (if there is
  one) for this mode.
  Log files stored in local directory.  (These are not part of state.)

- In local install mode:
  Current installed state found in /etc.  Local dir state also used.
  Default should offer to install any currently installed packages with
  updated versions present in local dir.  If a package has an updated
  version but it isn't in the local dir, it can't be offered for update
  but it would be nice if setup could highlight the fact.
  The local dir should be considered read-only, and all log/state info
  should be put in /etc and/or /var.

- In install from internet mode:
  Offerings based on setup.ini file(s).  Would be nice if setup
  could indicate which packages are already present in the local
  directory and which need downloading.  After selection, any package
  versions needed but not present are downloaded.  The local dir
  state should be updated accordingly.  After all downloads, install
  takes place just as for local install.    

I think setup nearly works like this already, which is probably why
I assumed that's how it would work.

Another wish (I think it's already been suggested) would be to
replace the rotary picker.  I'd like to see an expand-down - so if
you want to change from the default offered, you click on the line
and see a list of possibilities - all the versions (tagged with prev/curr/test),
and also reinstall(or refetch), source, source refetch, uninstall,
remove (from local dir) and delete source.  Not all would be
meaningful, depending on download/install mode.  [Ok, I know this
isn't going to happen, at least in the near future.]

Cliff.

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Bug reporting:         http://cygwin.com/bugs.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/